#include <stdlib.h>
#include <time.h>
#include <assert.h>
#include <stdio.h>
#define rep(E, F) for (E = 0; E < (F); E++)

void shuffle(int* a, int n)
{
	int i, t, k;
	rep(i, n)
	{
		k = rand()%(n - i);
		t = a[k];
		a[k] = a[n - 1 - i];
		a[n - 1 - i] = t;
	}
}

#if 0
int main(int argc, char** argv)
{
	assert(argc > 2);
	srand(atoi(argv[2]));
	int i, n = atoi(argv[1]);
	printf("%d\n", n);
	rep(i, n - 1) printf("%d ", rand()%3 + 1); printf("%d\n", rand()%3 + 1);
	return 0;
}
#else
int main(int argc, char** argv)
{
	assert(argc > 5);
	srand(atoi(argv[5]));
	int i, n = atoi(argv[1]), a = atoi(argv[2]), b = atoi(argv[3]), c = atoi(argv[4]);
	int v[n];
	rep(i, n)
	{
		if (i%(a + b + c) < a) v[i] = 1;
		else if (i%(a + b + c) < a + b) v[i] = 2;
		else v[i] = 3;
	}
	shuffle(v, n);
	printf("%d\n", n);
	rep(i, n - 1) printf("%d ", v[i]); printf("%d\n", v[i]);
	return 0;
}
#endif
