import sys
import re

line = sys.stdin.readline()
assert re.match('^[1-9][0-9]*\n$', line)
n = int(line.strip())
assert 1 <= n <= 10**5

hired = 0
tot_h = 0
for i in range(n):
    line = sys.stdin.readline()
    assert re.match('^(0|[1-9][0-9]*) (0|[1-9][0-9]*)\n$', line)
    f, h = map(int, line.strip().split())
    assert 0 <= f <= 10**6
    assert 0 <= h <= 10**6
    tot_h += h
    hired -= f
    assert hired >= 0
    hired += h

assert tot_h > 0
assert not sys.stdin.read()
sys.exit(42)

